# Generated by Django 2.2.10 on 2020-07-18 03:31
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import oneid_meta.models.config
import uuid


def init_pwd_config(apps, schema_editor):

    PasswordComplexityConfig = apps.get_model('oneid_meta', 'PasswordComplexityConfig')
    Site = apps.get_model('sites', 'Site')

    site, _ = Site.objects.get_or_create(id=settings.SITE_ID)
    pwd_config, _ = PasswordComplexityConfig.objects.get_or_create(site=site)

    if not settings.TESTING:
        PasswordComplexityConfig.min_length = getattr(settings.PASSWORD_COMPLEXITY, 'LENGTH', 0)
        PasswordComplexityConfig.min_upper = getattr(settings.PASSWORD_COMPLEXITY, 'UPPER', 0)
        PasswordComplexityConfig.min_lower = getattr(settings.PASSWORD_COMPLEXITY, 'LOWER', 0)
        PasswordComplexityConfig.min_letter = getattr(settings.PASSWORD_COMPLEXITY, 'LETTER', 0)
        PasswordComplexityConfig.min_digit = getattr(settings.PASSWORD_COMPLEXITY, 'DIGIT', 0)
        PasswordComplexityConfig.min_special = getattr(settings.PASSWORD_COMPLEXITY, 'SPECIAL', 0)
        PasswordComplexityConfig.min_word = getattr(settings.PASSWORD_COMPLEXITY, 'WORD', 0)


class Migration(migrations.Migration):

    dependencies = [
        ('sites', '0002_alter_domain_unique'),
        ('oneid_meta', '0076_aliyunssorole'),
    ]

    operations = [
        migrations.CreateModel(
            name='PasswordComplexityConfig',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('uuid', models.UUIDField(default=uuid.uuid4, unique=True)),
                ('is_del', models.BooleanField(default=False, verbose_name='是否删除')),
                ('is_active', models.BooleanField(default=True, verbose_name='是否可用')),
                ('updated', models.DateTimeField(auto_now=True, null=True, verbose_name='更新时间')),
                ('created', models.DateTimeField(auto_now_add=True, null=True, verbose_name='创建时间')),
                ('min_length', models.IntegerField(blank=True, default=0, verbose_name='最小长度')),
                ('min_upper', models.IntegerField(blank=True, default=0, verbose_name='大写字母限制')),
                ('min_lower', models.IntegerField(blank=True, default=0, verbose_name='小写字母限制')),
                ('min_letter', models.IntegerField(blank=True, default=0, verbose_name='字母限制')),
                ('min_digit', models.IntegerField(blank=True, default=0, verbose_name='数字限制')),
                ('min_special', models.IntegerField(blank=True, default=0, verbose_name='特殊字符限制')),
                ('min_word', models.IntegerField(blank=True, default=0, verbose_name='单词限制')),
                ('site', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, related_name='password_config', to='sites.Site')),
            ],
            options={
                'abstract': False,
            },
            bases=(models.Model, oneid_meta.models.config.SingletonConfigMixin),
        ),
        migrations.RunPython(init_pwd_config),
    ]
