# Generated by Django 2.2.10 on 2020-07-22 10:25

from django.db import migrations, models
import jsonfield.fields
import uuid


def init_i18n_mobile_config(apps, schema_editor):
    """默认支持中国国际号码"""
    I18NMobileConfig = apps.get_model('oneid_meta', 'I18NMobileConfig')
    I18NMobileConfig.objects.create(state='China', state_code='86', number_length=11, start_digital=[1])


class Migration(migrations.Migration):

    dependencies = [
        ('oneid_meta', '0077_pwdconfig'),
    ]

    operations = [
        migrations.CreateModel(
            name='I18NMobileConfig',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('uuid', models.UUIDField(default=uuid.uuid4, unique=True)),
                ('is_del', models.BooleanField(default=False, verbose_name='是否删除')),
                ('is_active', models.BooleanField(default=True, verbose_name='是否可用')),
                ('updated', models.DateTimeField(auto_now=True, null=True, verbose_name='更新时间')),
                ('created', models.DateTimeField(auto_now_add=True, null=True, verbose_name='创建时间')),
                ('state', models.CharField(max_length=128, unique=True, verbose_name='号码归属区域')),
                ('state_code', models.CharField(max_length=32, unique=True, verbose_name='国家区号')),
                ('number_length', models.IntegerField(default=None, null=True, verbose_name='号码固定长度')),
                ('start_digital', jsonfield.fields.JSONField(blank=True, default=[], verbose_name='首位数字限制集')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.RunPython(init_i18n_mobile_config)
    ]
